'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Header = require('./Header/Header.propTypes');

var _Header2 = _interopRequireDefault(_Header);

var _ItemEdit = require('./Items/Item/ItemEdit.propTypes');

var _ItemEdit2 = _interopRequireDefault(_ItemEdit);

var _Action = require('../Actions/Action');

var _Action2 = _interopRequireDefault(_Action);

var _Header3 = require('./Header/Header.component');

var _Header4 = _interopRequireDefault(_Header3);

var _HeaderInput = require('./Header/HeaderInput.component');

var _HeaderInput2 = _interopRequireDefault(_HeaderInput);

var _HeaderSelected = require('./Header/HeaderSelected.component');

var _HeaderSelected2 = _interopRequireDefault(_HeaderSelected);

var _Items = require('./Items/Items.component');

var _Items2 = _interopRequireDefault(_Items);

var _Enumeration = require('./Enumeration.scss');

var _Enumeration2 = _interopRequireDefault(_Enumeration);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DISPLAY_MODE_DEFAULT = 'DISPLAY_MODE_DEFAULT';
var DISPLAY_MODE_ADD = 'DISPLAY_MODE_ADD';
var DISPLAY_MODE_SEARCH = 'DISPLAY_MODE_SEARCH';
var DISPLAY_MODE_EDIT = 'DISPLAY_MODE_EDIT';
var DISPLAY_MODE_SELECTED = 'DISPLAY_MODE_SELECTED';

function enumerationClasses() {
	var _classNames;

	return (0, _classnames2.default)((_classNames = {}, _defineProperty(_classNames, _Enumeration2.default['tc-enumeration'], true), _defineProperty(_classNames, 'tc-enumeration', true), _classNames));
}

function Enumeration(props) {
	return _react2.default.createElement(
		'div',
		{ className: enumerationClasses() },
		_react2.default.createElement(HeaderEnumeration, props),
		_react2.default.createElement(ItemsEnumeration, props)
	);
}

Enumeration.propTypes = _extends({
	displayMode: _propTypes2.default.oneOf([DISPLAY_MODE_DEFAULT, DISPLAY_MODE_ADD, DISPLAY_MODE_SELECTED, DISPLAY_MODE_EDIT, DISPLAY_MODE_SEARCH]),
	inputRef: _propTypes2.default.func,
	required: _propTypes2.default.bool,
	headerError: _propTypes2.default.string,
	headerDefault: _propTypes2.default.arrayOf(_propTypes2.default.shape(_Header2.default)).isRequired,
	headerInput: _propTypes2.default.arrayOf(_propTypes2.default.shape(_Header2.default)),
	headerSelected: _propTypes2.default.arrayOf(_propTypes2.default.shape(_Header2.default)),
	items: _propTypes2.default.arrayOf(_propTypes2.default.shape({
		values: _propTypes2.default.arrayOf(_propTypes2.default.string)
	})).isRequired,
	searchCriteria: _propTypes2.default.string,
	itemsProp: _propTypes2.default.shape({
		key: _propTypes2.default.string,
		getItemHeight: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.number]),
		onSubmitItem: _propTypes2.default.func,
		onChangeItem: _propTypes2.default.func,
		onSelectItem: _propTypes2.default.func,
		onAbortItem: _propTypes2.default.func,
		onLoadData: _propTypes2.default.func,
		actionsDefault: _propTypes2.default.arrayOf(_propTypes2.default.shape(_Action2.default.propTypes)),
		actionsEdit: _propTypes2.default.arrayOf(_propTypes2.default.shape(_Action2.default.propTypes))
	}).isRequired,
	onInputChange: _propTypes2.default.func.isRequired,
	onAddKeyDown: _propTypes2.default.func,
	inputPlaceholder: _propTypes2.default.string,
	inputValue: _propTypes2.default.string,
	label: _propTypes2.default.string
}, _ItemEdit2.default);

function hintClasses() {
	var _classNames2;

	return (0, _classnames2.default)((_classNames2 = {}, _defineProperty(_classNames2, _Enumeration2.default['tc-enumeration-hint'], true), _defineProperty(_classNames2, 'tc-enumeration-hint', true), _classNames2));
}

var EMPTY_LIST_PLACEHOLDER_DEFAULT = 'The list is empty';
var EMPTY_LIST_PLACEHOLDER_SEARCH = 'No results';

function EmptyListPlaceholder(_ref) {
	var displayMode = _ref.displayMode;

	return _react2.default.createElement(
		'p',
		{ className: hintClasses() },
		displayMode === DISPLAY_MODE_DEFAULT ? EMPTY_LIST_PLACEHOLDER_DEFAULT : EMPTY_LIST_PLACEHOLDER_SEARCH
	);
}

EmptyListPlaceholder.propTypes = {
	displayMode: Enumeration.propTypes.displayMode
};

function ItemsEnumeration(_ref2) {
	var items = _ref2.items,
	    itemsProp = _ref2.itemsProp,
	    searchCriteria = _ref2.searchCriteria,
	    currentEdit = _ref2.currentEdit,
	    displayMode = _ref2.displayMode;

	if (items.length > 0) {
		return _react2.default.createElement(_Items2.default, {
			items: items,
			itemsProp: itemsProp,
			currentEdit: currentEdit,
			searchCriteria: searchCriteria
		});
	}
	return _react2.default.createElement(EmptyListPlaceholder, { displayMode: displayMode });
}

ItemsEnumeration.propTypes = _extends({
	items: Enumeration.propTypes.items,
	itemsProp: Enumeration.propTypes.itemsProp,
	searchCriteria: Enumeration.propTypes.searchCriteria
}, _ItemEdit2.default);

function HeaderEnumeration(_ref3) {
	var displayMode = _ref3.displayMode,
	    headerError = _ref3.headerError,
	    onInputChange = _ref3.onInputChange,
	    onAddKeyDown = _ref3.onAddKeyDown,
	    headerInput = _ref3.headerInput,
	    headerDefault = _ref3.headerDefault,
	    headerSelected = _ref3.headerSelected,
	    items = _ref3.items,
	    required = _ref3.required,
	    inputValue = _ref3.inputValue,
	    inputRef = _ref3.inputRef,
	    label = _ref3.label;

	switch (displayMode) {
		case DISPLAY_MODE_SEARCH:
			{
				var propsInput = {
					headerInput: headerInput,
					onInputChange: onInputChange,
					onAddKeyDown: onAddKeyDown,
					headerError: headerError,
					inputRef: inputRef,
					inputPlaceholder: 'Search'
				};
				return _react2.default.createElement(_HeaderInput2.default, propsInput);
			}
		case DISPLAY_MODE_ADD:
			{
				var _propsInput = {
					headerInput: headerInput,
					onInputChange: onInputChange,
					onAddKeyDown: onAddKeyDown,
					headerError: headerError,
					inputRef: inputRef,
					value: inputValue,
					inputPlaceholder: 'New entry'
				};
				return _react2.default.createElement(_HeaderInput2.default, _propsInput);
			}
		case DISPLAY_MODE_DEFAULT:
			{
				var propsDefault = {
					headerDefault: headerDefault,
					required: required,
					label: label
				};

				return _react2.default.createElement(_Header4.default, propsDefault);
			}

		case DISPLAY_MODE_SELECTED:
			{
				var propsSelected = {
					headerSelected: headerSelected,
					nbItemsSelected: items.filter(function (item) {
						return item.isSelected && item.isSelected === true;
					}).length
				};
				return _react2.default.createElement(_HeaderSelected2.default, propsSelected);
			}

		default:
			return null;
	}
}

HeaderEnumeration.propTypes = {
	headerError: Enumeration.propTypes.headerError,
	displayMode: Enumeration.propTypes.displayMode,
	headerInput: Enumeration.propTypes.headerInput,
	headerDefault: Enumeration.propTypes.headerDefault,
	headerSelected: Enumeration.propTypes.headerSelected,
	onInputChange: Enumeration.propTypes.onInputChange,
	onAddKeyDown: Enumeration.propTypes.onAddKeyDown,
	items: Enumeration.propTypes.items,
	required: Enumeration.propTypes.required,
	inputValue: Enumeration.propTypes.inputValue,
	inputRef: Enumeration.propTypes.inputRef,
	label: Enumeration.propTypes.label
};

exports.default = Enumeration;