'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Action = require('../../Actions/Action');

var _Action2 = _interopRequireDefault(_Action);

var _Header = require('./Header.component');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function HeaderCheckbox(_ref) {
	var headerDefault = _ref.headerDefault,
	    toggleAllChecked = _ref.toggleAllChecked,
	    toggleAllLabel = _ref.toggleAllLabel,
	    onToggleAll = _ref.onToggleAll;

	var toggleAllId = 'toggle-all';
	return _react2.default.createElement(
		'header',
		{ className: (0, _Header.headerClasses)() },
		_react2.default.createElement(
			'div',
			{ className: 'checkbox' },
			_react2.default.createElement(
				'label',
				{ htmlFor: toggleAllId },
				_react2.default.createElement('input', {
					id: toggleAllId,
					type: 'checkbox',
					onChange: onToggleAll,
					checked: !!toggleAllChecked
				}),
				_react2.default.createElement(
					'strong',
					null,
					toggleAllLabel
				)
			)
		),
		(0, _Header.renderActions)(headerDefault)
	);
}

HeaderCheckbox.propTypes = {
	headerDefault: _react.PropTypes.arrayOf(_react.PropTypes.shape(_Action2.default.propTypes)).isRequired,
	toggleAllChecked: _react.PropTypes.bool,
	toggleAllLabel: _react.PropTypes.string,
	onToggleAll: _react.PropTypes.func
};

HeaderCheckbox.defaultProps = {
	toggleAllLabel: 'Toggle all'
};

exports.default = HeaderCheckbox;